within ModelicaTableAdditions.Blocks;
package Test "Test models"
  extends Modelica.Icons.ExamplesPackage;
  model TestTables "Test and compare the table blocks"
    extends Modelica.Icons.Example;
    ModelicaTableAdditions.Blocks.Sources.CombiTimeTable combiTimeTableCsv(
      tableOnFile=true,
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.csv"),
      nHeaderLines=1,
      columns={2})
      annotation (Placement(transformation(extent={{-40,60},{-20,80}})));
    Sources.CombiTimeTable combiTimeTableJson(
      tableOnFile=true,
      tableName="tab1",
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.json"),
      columns={2})
      annotation (Placement(transformation(extent={{40,60},{60,80}})));
    Modelica.Blocks.Sources.CombiTimeTable combiTimeTableTxt(
      tableOnFile=true,
      tableName="tab1",
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.txt"),
      columns={2})
      annotation (Placement(transformation(extent={{120,60},{140,80}})));
    Modelica.Blocks.Sources.ContinuousClock clock11
      annotation (Placement(transformation(extent={{-80,20},{-60,40}})));
    ModelicaTableAdditions.Blocks.Tables.CombiTable1Ds combiTable1DsCsv(
      tableOnFile=true,
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.csv"),
      nHeaderLines=1,
      columns={2})
      annotation (Placement(transformation(extent={{-40,20},{-20,40}})));
    Modelica.Blocks.Sources.ContinuousClock clock12
      annotation (Placement(transformation(extent={{-80,-20},{-60,0}})));
    ModelicaTableAdditions.Blocks.Tables.CombiTable1Dv combiTable1DvCsv(
      tableOnFile=true,
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.csv"),
      nHeaderLines=1,
      columns={2})
      annotation (Placement(transformation(extent={{-40,-20},{-20,0}})));
    Modelica.Blocks.Sources.ContinuousClock clock21
      annotation (Placement(transformation(extent={{0,20},{20,40}})));
    Tables.CombiTable1Ds combiTable1DsJson(
      tableOnFile=true,
      tableName="tab1",
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.json"),
      columns={2})
      annotation (Placement(transformation(extent={{40,20},{60,40}})));
    Modelica.Blocks.Sources.ContinuousClock clock22
      annotation (Placement(transformation(extent={{0,-20},{20,0}})));
    Tables.CombiTable1Dv combiTable1DvJson(
      tableOnFile=true,
      tableName="tab1",
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.json"),
      columns={2})
      annotation (Placement(transformation(extent={{40,-20},{60,0}})));
    Modelica.Blocks.Sources.ContinuousClock clock31
      annotation (Placement(transformation(extent={{80,20},{100,40}})));
    Modelica.Blocks.Tables.CombiTable1Ds combiTable1DsTxt(
      tableOnFile=true,
      tableName="tab1",
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.txt"),
      columns={2})
      annotation (Placement(transformation(extent={{120,20},{140,40}})));
    Modelica.Blocks.Sources.ContinuousClock clock32
      annotation (Placement(transformation(extent={{80,-20},{100,0}})));
    Modelica.Blocks.Tables.CombiTable1Dv combiTable1DvTxt(
      tableOnFile=true,
      tableName="tab1",
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.txt"),
      columns={2})
      annotation (Placement(transformation(extent={{120,-20},{140,0}})));
  equation
    connect(clock12.y, combiTable1DvCsv.u[1])
      annotation (Line(points={{-59,-10},{-42,-10}}, color={0,0,127}));
    connect(clock32.y,combiTable1DvTxt. u[1])
      annotation (Line(points={{101,-10},{118,-10}}, color={0,0,127}));
    connect(clock11.y, combiTable1DsCsv.u)
      annotation (Line(points={{-59,30},{-42,30}}, color={0,0,127}));
    connect(clock31.y, combiTable1DsTxt.u)
      annotation (Line(points={{101,30},{118,30}}, color={0,0,127}));
    connect(clock22.y, combiTable1DvJson.u[1])
      annotation (Line(points={{21,-10},{38,-10}}, color={0,0,127}));
    connect(clock21.y, combiTable1DsJson.u)
      annotation (Line(points={{21,30},{38,30}}, color={0,0,127}));
    annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,100}})), Diagram(
          coordinateSystem(preserveAspectRatio=false, extent={{-100,-40},{160,100}})),
      experiment(StopTime=45));
  end TestTables;

  model TestFileUpdateTimeTable "Update table source file on events"
    extends Modelica.Icons.Example;
    ModelicaTableAdditions.Blocks.Sources.FileUpdateTimeTable fileUpdateTimeTable(
      tableName="tab1",
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Tables/test.txt"),
      forceRead=true)
      annotation (Placement(transformation(extent={{-60,20},{-40,40}})));
    Modelica.Blocks.Sources.BooleanExpression booleanExpression(y=sample(0, 10))
      annotation (Placement(transformation(extent={{-78,52},{-58,72}})));
  equation
    connect(fileUpdateTimeTable.updateTrigger, booleanExpression.y)
      annotation (Line(points={{-50,42},{-50,62},{-57,62}}, color={255,0,255}));
    annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,100}})), Diagram(
          coordinateSystem(preserveAspectRatio=false, extent={{-100,0},{0,100}})),
      experiment(StopTime=45));
  end TestFileUpdateTimeTable;

  model TestWeatherEPWFile "Weather data from EPW file"
    extends Modelica.Icons.Example;
    constant Modelica.Units.SI.EnergyFluence unitEnergyFluence = 1;
    record EPWCols "Column indices of EPW file"
      constant Integer 'dry bulb temperature' = 2 "EPW index for dry bulb temperature in degC";
      constant Integer 'dew point temperature' = 3 "EPW index for dew point temperature in degC";
      constant Integer 'relative humidity' = 4 "EPW index for relative humidity in %";
      constant Integer 'atmospheric pressure' = 5 "EPW index for atmospheric_pressure in Pa";
      constant Integer 'global solar' = 9 "EPW index for global horizontal radiation in W.h/m2";
      constant Integer 'normal solar' = 10 "EPW index for direct normal radiation in W.h/m2";
      constant Integer 'diffuse solar' = 11 "EPW index for diffuse horizontal radiation in W.h/m2";
      constant Integer 'wind speed' = 17 "EPW index for wind speed in m/s";
    end EPWCols;
    ModelicaTableAdditions.Blocks.Sources.CombiTimeTable combiTimeTable(
      tableOnFile=true,
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Weather/weather.epw"),
      columns={EPWCols.'dry bulb temperature', EPWCols.'normal solar'},
      smoothness=ModelicaTableAdditions.Blocks.Types.Smoothness.ModifiedContinuousDerivative,
      extrapolation=Modelica.Blocks.Types.Extrapolation.HoldLastPoint,
      shiftTime=1800)
      annotation (Placement(transformation(extent={{-80,40},{-60,60}})));
    Modelica.Blocks.Math.UnitConversions.From_degC 'dry bulb temperature'(
      y(displayUnit="degC"))
      annotation (Placement(transformation(extent={{-40,60},{-20,80}})));
    Modelica.Blocks.Math.Gain 'normal solar'(
      k=3600*unitEnergyFluence,
      y(unit="J/m2", quantity="EnergyFluence", displayUnit="kW.h/m2"))
      annotation (Placement(transformation(extent={{-40,20},{-20,40}})));
  equation
    connect(combiTimeTable.y[1], 'dry bulb temperature'.u)
      annotation (Line(points={{-59,50},{-52,50},{-52,70},{-42,70}}, color={0,0,127}));
    connect(combiTimeTable.y[2], 'normal solar'.u)
      annotation (Line(points={{-42,30},{-52,30},{-52,50},{-59,50}}, color={0,0,127}));
    annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,100}})), Diagram(
          coordinateSystem(preserveAspectRatio=false, extent={{-100,0},{0,100}})),
      experiment(StopTime=31536000, Interval=1800));
  end TestWeatherEPWFile;

  model TestWeatherCSVFile "Weather data from CSV file"
    extends Modelica.Icons.Example;
    ModelicaTableAdditions.Blocks.Sources.CombiTimeTable combiTimeTable(
      tableOnFile=true,
      fileName=Modelica.Utilities.Files.loadResource("modelica://ModelicaTableAdditions/Resources/Data/Weather/weather.csv"),
      columns={7},
      nHeaderLines=1,
      smoothness=ModelicaTableAdditions.Blocks.Types.Smoothness.ModifiedContinuousDerivative,
      extrapolation=Modelica.Blocks.Types.Extrapolation.HoldLastPoint,
      timeScale=3600,
      shiftTime=1800)
      annotation (Placement(transformation(extent={{-80,40},{-60,60}})));
    Modelica.Blocks.Math.UnitConversions.From_degC 'temperature'(
      y(displayUnit="degC"))
      annotation (Placement(transformation(extent={{-40,40},{-20,60}})));
  equation
    connect(combiTimeTable.y[1], 'temperature'.u)
      annotation (Line(points={{-59,50},{-42,50}}, color={0,0,127}));
    annotation (Icon(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{100,100}})), Diagram(
          coordinateSystem(preserveAspectRatio=false, extent={{-100,0},{0,100}})),
      experiment(StopTime=31536000, Interval=1800));
  end TestWeatherCSVFile;
end Test;
